unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ExtCtrls, ComCtrls, Menus, About;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    Panel3: TPanel;
    FilterComboBox1: TFilterComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel4: TPanel;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    FileListBox2: TFileListBox;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    SaveDialog1: TSaveDialog;
//    procedure TForm1.FileListBox2Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FileListBox2Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TPalette=array[0..255]of record
                             R,G,B,F: Byte;
                           end;
const
  Product_Name='Age Of Empires SLP Converter';
  Product_Version='v0.9 Beta';
  Product_Data='25.09.2001';
  Author_Name=' ';
  Author_EMail='collapse_forever@mail.ru';
  Author_http='termius.narod.ru';

var
  Form1: TForm1;
  BMPPalette: TPalette;
  CurDir: string;
  Buffer: array[0..1024]of char;
  BmpID: ARRAY[1..2]OF Char;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;
  TotalSprites: LongInt;
  FName: string;
  Rows: array of record
                   MarginLeft: SmallInt;
                   MarginRight: SmallInt;
                   Offset: LongInt;
                 end;
  Entries: array of record
                      RowsOffset: LongInt;
                      MarginOffset: LongInt;
                      Junk: array[1..8]of char;
                      Width: LongInt;
                      Height: LongInt;
                      Unknown_1: LongInt;
                      Unknown_2: LongInt;
                    end;

  procedure Expand(Source: Byte; var SType,SLength: Byte);
  function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;

implementation

{$R *.DFM}

procedure TForm1.FileListBox2Click(Sender: TObject);
var
  TempStream: TMemoryStream;
  i: Integer;
begin
  LoadPalette(FileListBox2.FileName,True,BMPPalette);
  TempStream:=TMemoryStream.Create;
  Image1.Picture.Bitmap.SaveToStream(TempStream);
  TempStream.Seek($36,soFromBeginning);
  for i:=0 to 255 do
  begin
    TempStream.Write(BMPPalette[i].R,1);
    TempStream.Write(BMPPalette[i].G,1);
    TempStream.Write(BMPPalette[i].B,1);
    TempStream.Write(BMPPalette[i].F,1);
  end;
  TempStream.Seek(0,soFromBeginning);
  Image1.Picture.Bitmap.LoadFromStream(TempStream);
  TempStream.Free;
end;

procedure Expand(Source: Byte; var SType,SLength: Byte);
var
  b: Byte;
begin
{         }
  b:=Source shl 4;
  SType:=b shr 4;
  SLength:=Source shr 4;
{  b:=Source shl 6;
  SType:=b shr 6;
  SLength:=Source shr 2;}
end;

function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;
var
  F: TFileStream;
  i: Byte;
begin
  if not(FileExists(FName))then
  begin
    LoadPalette:=False;
    Exit;
  end;
  LoadPalette:=True;
  F:=TFileStream.Create(FName,fmOpenRead);
  for i:=0 to 255 do
  begin
    if Invert then
    begin
      F.Read(Pal[i].B,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].R,1);
    end else
    begin
      F.Read(Pal[i].R,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].B,1);
    end;
    Pal[i].F:=$00;
  end;
  F.Free;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
var
  id: array[1..2]of char;
  F: TFileStream;
  i: LongInt;
begin
  FName:=FileListBox1.FileName;
  F:=TFileStream.Create(FName,fmOpenRead);
  F.Read(id,2);
  if not((id[1]='2')and(id[2]='.'))then
  begin
    ShowMessage('  !');
    F.Free;
    Exit;
  end;
  F.Seek($04,soFromBeginning);
  F.Read(TotalSprites,4);
  SetLength(Entries,TotalSprites);
  F.Seek($20,soFromBeginning);
  ListBox1.Items.Clear;
  for i:=1 to TotalSprites do
  begin
    F.Read(Entries[i-1],32);
    ListBox1.Items.Add(IntToStr(i));
  end;
  F.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  CurDir:=GetCurrentDir;
  SaveDialog1.InitialDir:=CurDir;
  if not FileExists (CurDir+'\default.pal') then
  begin
    ShowMessage('     '+CurDir+'\default.pal !');
  end else
  begin
    if DirectoryExists(CurDir+'\palettes') then FileListBox2.Directory:=CurDir+'\palettes';
    LoadPalette(CurDir+'\default.pal',True,BMPPalette);
    FileListBox2.ItemIndex:=0;
  end;
  BmpID[1]:='B';
  BmpID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  i,id,Add: LongInt;
//  F: TFileStream;
  F: TMemoryStream;
  FBmp,FTemp: TMemoryStream;
  TotalLength,FullLength,SavePos: LongInt;
  b1,bT,bL: Byte;
  ML,MR,TT,RL: Word;
  DoLeftNext,DoRightNext: Boolean;
begin
//  ListBox2.Items.Clear;
  id:=ListBox1.ItemIndex;
  SetLength(Rows,Entries[id].Height);
//  F:=TFileStream.Create(FName,fmOpenRead);
  F:=TMemoryStream.Create;
  F.LoadFromFile(FName);
  F.Seek(Entries[id].MarginOffset,soFromBeginning);
  DoLeftNext:=False;
  DoRightNext:=False;
  SavePos:=F.Position;
  for i:=Entries[id].Height downto 1 do
  begin
    F.Position:=SavePos+(i-1)*4;
    F.Read(ML,2);
    F.Read(MR,2);
    Rows[i-1].MarginLeft:=ML;
    Rows[i-1].MarginRight:=MR;
    if (ML=$8000)then Rows[i-1].MarginLeft:=Rows[i].MarginLeft;
    if (MR=$8000)then Rows[i-1].MarginRight:=Rows[i].MarginRight;
  end;
  F.Seek(Entries[id].RowsOffset,soFromBeginning);
  for i:=1 to Entries[id].Height do F.Read(Rows[i-1].Offset,4);
  {***    }
  Add:=Round(Int((4*(1-(Frac(Entries[id].Width/4))))));
  if Add=4 then Add:=0;
  {***  }
  BMPHeader.x:=Entries[id].Width;
  BMPHeader.y:=Entries[id].Height;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  {***  }
  FBMP:=TMemoryStream.Create;
  FBMP.Write(BMPid,SizeOf(BMPid));
  FBMP.Write(BMPHeader,SizeOf(BMPHeader));
  FBMP.Write(BMPPalette,SizeOf(BMPPalette));
  FullLength:=Entries[id].Width;
  FTemp:=TMemoryStream.Create;
  for i:=1 to Entries[id].Height do
//  for i:=1 to 13 do
  begin
//    ListBox2.Items.Add('***** '+IntToStr(i));
    {***   }
    if Rows[i-1].MarginLeft>0 then
    begin
      FillChar(Buffer,256,$00);
      FTemp.Write(Buffer,Rows[i-1].MarginLeft);
    end;
//    ListBox2.Items.Add('- L:'+IntToStr(Rows[i-1].MarginLeft));
    {***   }
    TotalLength:=Rows[i-1].MarginLeft+Rows[i-1].MarginRight;
    F.Seek(Rows[i-1].Offset,soFromBeginning);
    repeat
      F.Read(b1,1);
      Expand(b1,bT,bL);
      FillChar(Buffer,256,$00);
      if b1=0 then Break;
      case bT of
      $0:begin //00
           bL:=(bL shl 2);
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $1:begin //01
           bL:=(bL shl 2);
           FillChar(Buffer,bL,$00);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $2:begin //10
           TT:=bL;
           TT:=TT shl 8;
           F.Read(bL,1);
           rL:=bL+TT;
           F.Read(Buffer,rL);
           FTemp.Write(Buffer,rL);
           TotalLength:=TotalLength+rL;
         end;
      $3:begin
           if bL=0 then F.Read(bL,1);
           FillChar(Buffer,bL,$00);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $4:begin //00
           bL:=(bL shl 2)+1;
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $5:begin //01
           bL:=(b1 shr 2);
           FillChar(Buffer,bL,$00);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $6:begin //10
           if bL=0 then F.Read(bL,1);
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $7:begin //11
           if bL=0 then F.Read(bl,1);
           F.Read(b1,1);
           FillChar(Buffer,bL,b1);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $8:begin //00
           bL:=(bL shl 2)+2;
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $9:begin //01
           bL:=(bL shl 2)+2;
           FillChar(Buffer,bL,$00);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $A:begin //10
           bL:=bL;
           F.Read(b1,1);
           FillChar(Buffer,bL,b1);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $B:begin //11
           if bL=0 then F.Read(bL,1);
           FillChar(Buffer,bL,$78);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $C:begin //00
           bL:=(bL shl 2)+3;
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $D:begin //01
           bL:=(bL shl 2)+3;
           FillChar(Buffer,bL,$00);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $E:begin
           F.Read(Buffer,bL);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      $F:begin //11
//           if bL=0 then F.Read(bL,1);
           F.Read(b1,1);
           FillChar(Buffer,bL,b1);
           FTemp.Write(Buffer,bL);
           TotalLength:=TotalLength+bL;
         end;
      end;
//      ListBox2.Items.Add(IntToStr(bT)+' : '+IntToStr(bL)+':'+IntToStr(TotalLength));
    until TotalLength>=FullLength;
    {***   }
    if Rows[i-1].MarginRight>0 then
    begin
      FillChar(Buffer,256,$00);
      FTemp.Write(Buffer,Rows[i-1].MarginRight);
    end;
//    ListBox2.Items.Add('- R:'+IntToStr(Rows[i-1].MarginRight));
//    ListBox2.Items.Add('+++ '+IntToStr(TotalLength)+' : '+IntToStr(FullLength));
    if Add>0 then FTemp.Write(Buffer,Add);
  end;
  for i:=Entries[id].Height downto 1 do
  begin
    FTemp.Seek((i-1)*(Entries[id].Width+Add),soFromBeginning);
    FBMP.CopyFrom(FTemp,Entries[id].Width+Add);
  end;
//  FTemp.Seek(0,soFromBeginning);
//  FBMP.CopyFrom(FTemp,FTemp.Size);
  FBMP.Seek(0,soFromBeginning);
  Image1.Picture.Bitmap.LoadFromStream(FBMP);
  FBMP.SaveToFile(CurDir+'\1.bmp');
  FBMP.Free;
  F.Free;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  ShowAbout(Product_Name,Product_Version,Product_Data,Author_Name,Author_EMail,Author_http);
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then Exit;
  Image1.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
end;

end.
